# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.WebSecurityScanner.V1.Model.IapCredential do
  @moduledoc """
  Describes authentication configuration for Identity-Aware-Proxy (IAP).

  ## Attributes

  *   `iapTestServiceAccountInfo` (*type:* `GoogleApi.WebSecurityScanner.V1.Model.IapTestServiceAccountInfo.t`, *default:* `nil`) - Authentication configuration when Web-Security-Scanner service account is added in Identity-Aware-Proxy (IAP) access policies.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :iapTestServiceAccountInfo =>
            GoogleApi.WebSecurityScanner.V1.Model.IapTestServiceAccountInfo.t() | nil
        }

  field(:iapTestServiceAccountInfo,
    as: GoogleApi.WebSecurityScanner.V1.Model.IapTestServiceAccountInfo
  )
end

defimpl Poison.Decoder, for: GoogleApi.WebSecurityScanner.V1.Model.IapCredential do
  def decode(value, options) do
    GoogleApi.WebSecurityScanner.V1.Model.IapCredential.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.WebSecurityScanner.V1.Model.IapCredential do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
