# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.WebSecurityScanner.V1alpha.Model.VulnerableHeaders do
  @moduledoc """
  Information about vulnerable or missing HTTP Headers.

  ## Attributes

  *   `headers` (*type:* `list(GoogleApi.WebSecurityScanner.V1alpha.Model.Header.t)`, *default:* `nil`) - List of vulnerable headers.
  *   `missingHeaders` (*type:* `list(GoogleApi.WebSecurityScanner.V1alpha.Model.Header.t)`, *default:* `nil`) - List of missing headers.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :headers => list(GoogleApi.WebSecurityScanner.V1alpha.Model.Header.t()) | nil,
          :missingHeaders => list(GoogleApi.WebSecurityScanner.V1alpha.Model.Header.t()) | nil
        }

  field(:headers, as: GoogleApi.WebSecurityScanner.V1alpha.Model.Header, type: :list)
  field(:missingHeaders, as: GoogleApi.WebSecurityScanner.V1alpha.Model.Header, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.WebSecurityScanner.V1alpha.Model.VulnerableHeaders do
  def decode(value, options) do
    GoogleApi.WebSecurityScanner.V1alpha.Model.VulnerableHeaders.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.WebSecurityScanner.V1alpha.Model.VulnerableHeaders do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
